#
# Conditional build:
%bcond_without	introspection	# disable introspection
#
# it's not possible to build this with debuginfo on 32bit archs due to
# memory constraints during linking
%ifarch %{ix86} x32
%define		_enable_debug_packages		0
%endif
Summary:	Port of WebKit embeddable web component to GTK+ 2
Summary(pl.UTF-8):	Port osadzalnego komponentu WWW WebKit do GTK+ 2
Name:		gtk-webkit
# note: 2.4.x is the last series with webkitgtk-1 API and GTK+ 2.x support
Version:	2.4.11
Release:	9
License:	BSD-like
Group:		X11/Libraries
Source0:	http://webkitgtk.org/releases/webkitgtk-%{version}.tar.xz
# Source0-md5:	24a25ccc30a7914ae50922aedf24b7bc
Patch0:		x32.patch
Patch1:		abs.patch
Patch2:		%{name}-icu59.patch
Patch3:		%{name}-icu65.patch
Patch4:		glib2.68.patch
Patch5:		icu68.patch
Patch6:		grammar.patch
Patch7:		volatile.patch
URL:		http://webkitgtk.org/
BuildRequires:	/usr/bin/ld.gold
BuildRequires:	EGL-devel
BuildRequires:	OpenGL-GLX-devel
BuildRequires:	at-spi2-core-devel >= 2.6.0
BuildRequires:	autoconf >= 2.60
BuildRequires:	automake
BuildRequires:	bison >= 1.875
BuildRequires:	cairo-devel >= 1.10
BuildRequires:	enchant-devel >= 0.22
BuildRequires:	flex >= 2.5.33
BuildRequires:	fontconfig-devel >= 2.5.0
BuildRequires:	freetype-devel >= 1:2.1.8
BuildRequires:	gcc-c++ >= 6:4.7
BuildRequires:	geoclue2-devel >= 2.1.5
BuildRequires:	gettext-tools
BuildRequires:	glib2-devel >= 1:2.36.0
BuildRequires:	glibc-misc
%{?with_introspection:BuildRequires:	gobject-introspection-devel >= 1.32.0}
BuildRequires:	gperf
BuildRequires:	gstreamer-devel >= 1.0.3
BuildRequires:	gstreamer-plugins-base-devel >= 1.0.3
BuildRequires:	libstdc++-devel >= 6:4.7
BuildRequires:	gtk+2-devel >= 2:2.24.10
BuildRequires:	gtk-doc >= 1.10
BuildRequires:	harfbuzz-devel >= 0.9.7
BuildRequires:	harfbuzz-icu-devel >= 0.9.7
BuildRequires:	libicu-devel >= 59
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	libsecret-devel
BuildRequires:	libsoup-devel >= 2.42.0
BuildRequires:	libstdc++-devel
# libtool with -fuse-ld= gcc option support
BuildRequires:	libtool >= 2:2.4.2-13
BuildRequires:	libwebp-devel
BuildRequires:	libxml2-devel >= 1:2.6.30
BuildRequires:	libxslt-devel >= 1.1.7
BuildRequires:	pango-devel >= 1:1.32.0
BuildRequires:	perl-base
BuildRequires:	pkgconfig
BuildRequires:	python
BuildRequires:	rpmbuild(macros) >= 1.592
BuildRequires:	ruby
BuildRequires:	sqlite3-devel >= 3
BuildRequires:	tar >= 1:1.22
BuildRequires:	udev-glib-devel
BuildRequires:	xorg-lib-libXcomposite-devel
BuildRequires:	xorg-lib-libXdamage-devel
BuildRequires:	xorg-lib-libXrender-devel
BuildRequires:	xorg-lib-libXt-devel
BuildRequires:	xz
BuildRequires:	zlib-devel
Requires:	cairo >= 1.10
Requires:	enchant >= 0.22
Requires:	fontconfig-libs >= 2.5.0
Requires:	freetype >= 1:2.1.8
Requires:	glib2 >= 1:2.36.0
Requires:	gstreamer >= 1.0.3
Requires:	gstreamer-plugins-base >= 1.0.3
Requires:	gtk+2 >= 2:2.24.10
Requires:	harfbuzz >= 0.9.7
Requires:	libsoup >= 2.42.0
Requires:	libxml2 >= 1:2.6.30
Requires:	libxslt >= 1.1.7
Requires:	pango >= 1:1.32.0
%{?with_introspection:Conflicts:	gir-repository < 0.6.5-7}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# __once_call, __once_called non-function symbols from libstdc++
%define		skip_post_check_so	lib.*gtk-1.0.*

%description
gtk-webkit is a port of the WebKit embeddable web component to GTK+ 2.

%description -l pl.UTF-8
gtk-webkit to port osadzalnego komponentu WWW WebKit do GTK+ 2.

%package devel
Summary:	Development files for WebKit for GTK+ 2
Summary(pl.UTF-8):	Pliki programistyczne komponentu WebKit dla GTK+ 2
Group:		X11/Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	glib2-devel >= 1:2.36.0
Requires:	gtk+2-devel >= 2:2.24.10
Requires:	libsoup-devel >= 2.42.0
Requires:	libstdc++-devel

%description devel
Development files for WebKit for GTK+ 2.

%description devel -l pl.UTF-8
Pliki programistyczne komponentu WebKit dla GTK+ 2.

%prep
%setup -q -n webkitgtk-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1

%build
%{__libtoolize}
%{__aclocal} -I Source/autotools
%{__autoconf}
%{__autoheader}
%{__automake}
%if "%{cxx_version}" >= "4.9"
CXXFLAGS="%{rpmcxxflags} -fno-delete-null-pointer-checks"
%endif
%configure \
%ifarch %{x8664}
	LDFLAGS="%{rpmldflags} -fuse-ld=gold" \
%else
	LDFLAGS="%{rpmldflags} -fuse-ld=bfd -Wl,--no-keep-memory" \
%endif
	--disable-gtk-doc \
	--disable-silent-rules \
	--disable-webkit2 \
	--enable-geolocation \
	--enable-glx \
	%{__enable_disable introspection} \
	--enable-webgl \
	--with-gtk=2.0 \
	--with-html-dir=%{_gtkdocdir}

%{__make} -j1

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# obsoleted by pkg-config
%{__rm} $RPM_BUILD_ROOT%{_libdir}/lib*-1.0.la
# packaged in gtk-webkit3
%{__rm} -r $RPM_BUILD_ROOT%{_gtkdocdir}/{webkitgtk,webkitdomgtk}

%find_lang WebKitGTK-2.0

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files -f WebKitGTK-2.0.lang
%defattr(644,root,root,755)
%doc ChangeLog NEWS
%attr(755,root,root) %{_bindir}/jsc-1
%attr(755,root,root) %{_libdir}/libwebkitgtk-1.0.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libwebkitgtk-1.0.so.0
%attr(755,root,root) %{_libdir}/libjavascriptcoregtk-1.0.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libjavascriptcoregtk-1.0.so.0
%if %{with introspection}
%{_libdir}/girepository-1.0/JavaScriptCore-1.0.typelib
%{_libdir}/girepository-1.0/WebKit-1.0.typelib
%endif
%dir %{_datadir}/webkitgtk-1.0
%{_datadir}/webkitgtk-1.0/images
%{_datadir}/webkitgtk-1.0/resources

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libjavascriptcoregtk-1.0.so
%attr(755,root,root) %{_libdir}/libwebkitgtk-1.0.so
%if %{with introspection}
%{_datadir}/gir-1.0/JavaScriptCore-1.0.gir
%{_datadir}/gir-1.0/WebKit-1.0.gir
%endif
%{_includedir}/webkitgtk-1.0
%{_pkgconfigdir}/javascriptcoregtk-1.0.pc
%{_pkgconfigdir}/webkit-1.0.pc
%changelog
* Fri Aug 13 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/gtk-webkit.git;a=log;h=master

* Fri Aug 13 2021 Jan Palus <atler@pld-linux.org> 7a0f762
- icu rebuild

* Thu Aug 12 2021 Jan Palus <atler@pld-linux.org> c6c75c0
- build fixes from arch

* Wed Aug 11 2021 Jan Palus <atler@pld-linux.org> 941b35b
- rediff patches

* Thu Jul 02 2020 Jan Palus <atler@pld-linux.org> 14c9515
- icu 67 rebuild
- release 8 (by relup.sh)

* Tue Oct 08 2019 Jan Palus <atler@pld-linux.org> 4a318b5
- attempt to fix build against icu 65; rel 7

* Sun Apr 14 2019 Jan Rękorajski <baggins@pld-linux.org> c6292b5
- icu/boost rebuild
- release 6 (by relup.sh)

* Mon Jul 30 2018 Jakub Bogusz <qboosh@pld-linux.org> d9cc083
- release 5: recompile with -fno-delete-null-pointer-checks (relies on this==NULL checks); disable debuginfo for 32-bit x86 ABIs

* Sun Apr 23 2017 Jakub Bogusz <qboosh@pld-linux.org> d2b8825
- added icu59 patch (fix build with icu >= 59)
- release 4 (rebuild with icu 59)

* Sat Mar 11 2017 Jan Rękorajski <baggins@pld-linux.org> bdcbb32
- fix overloaded 'abs(gdouble)' is ambiguous error
- rel 3

* Fri Mar 10 2017 Jan Rękorajski <baggins@pld-linux.org> 7ed1b87
- rebuild with icu 58.2
- release 2 (by relup.sh)

* Wed May 18 2016 Jakub Bogusz <qboosh@pld-linux.org> 2ab8857
- updated to 2.4.11 (Security fixes: CVE-2015-1120, CVE-2015-1076, CVE-2015-1071,
  CVE-2015-1081, CVE-2015-1122, CVE-2015-1155, CVE-2014-1748, CVE-2015-3752,
  CVE-2015-5809, CVE-2015-5928, CVE-2015-3749, CVE-2015-3659, CVE-2015-3748,
  CVE-2015-3743, CVE-2015-3731, CVE-2015-3745, CVE-2015-5822, CVE-2015-3658,
  CVE-2015-3741, CVE-2015-3727, CVE-2015-5801, CVE-2015-5788, CVE-2015-3747,
  CVE-2015-5794, CVE-2015-1127, CVE-2015-1153, CVE-2015-1083)

* Mon May 16 2016 Elan Ruusamäe <glen@delfi.ee> 1265cad
- icu-57.1 rebuild
- release 5 (by relup.sh)

* Wed Mar 23 2016 Jan Rękorajski <baggins@pld-linux.org> 438bd49
- rebuild with cairo without GL support
- rel 4

* Sun Jan 03 2016 Jan Rękorajski <baggins@pld-linux.org> 240819d
- release 3 (by relup.sh)

* Mon Nov 16 2015 Jan Rękorajski <baggins@pld-linux.org> 2ee9b31
- release 2 (by relup.sh)

* Mon Jun 08 2015 Jan Rękorajski <baggins@pld-linux.org> 1d41d1d
- up to 2.4.9

* Sat Mar 07 2015 Jan Rękorajski <baggins@pld-linux.org> 705ed32
- release 3 (by relup.sh)

* Sat Mar 07 2015 Jan Rękorajski <baggins@pld-linux.org> f7dbae7
- try to solve ld memory exhaution issue on 32bit archs

* Fri Mar 06 2015 Jan Rękorajski <baggins@pld-linux.org> 143c89e
- fixed build on x32; rel 2

* Sun Jan 25 2015 Jakub Bogusz <qboosh@pld-linux.org> a6fd303
- added version note

